unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Registry, Hives;

type
  TForm1 = class(TForm)
    ListBox1: TListBox;
    CheckBox1: TCheckBox;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    GroupBox2: TGroupBox;
    Button1: TButton;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Button2: TButton;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
  private
    procedure LireInformationsGenerales;
    procedure AfficherInformationsPrivees;
    procedure AccesRegistre(TypeAcces: byte);
    procedure ActionHKCU(TypeAcces: byte ; Utilisateurs: TUtilisateurs ; i: integer);
  public
    { Dclarations publiques }
  end;

const A_LIRE=1;
      A_MODIFIER=2;

var
  Form1: TForm1;
  Utilisateurs: TUtilisateurs;

implementation

{$R *.dfm}

// Procdures objets

procedure TForm1.FormCreate(Sender: TObject);
begin LireInformationsGenerales; end; // Listing des utilisateurs au dmarrage

procedure TForm1.FormDestroy(Sender: TObject);
begin Setlength(Utilisateurs, 0); end; // Libration de la mmoire

procedure TForm1.CheckBox1Click(Sender: TObject);
begin LireInformationsGenerales; end;

procedure TForm1.ListBox1Click(Sender: TObject);
begin AfficherInformationsPrivees; end;

procedure TForm1.Button1Click(Sender: TObject);
begin AccesRegistre(A_LIRE); end; // Lance le chargement du registre en mode lecture

procedure TForm1.Button2Click(Sender: TObject);
begin AccesRegistre(A_MODIFIER); end; // Lance le chargement du registre en mode criture

procedure TForm1.Edit1Change(Sender: TObject);
begin if Copy(Edit1.Text,1,1)<>'\' then begin Edit1.Text:='\'+Edit1.Text; Edit1.SelStart:=1; end; end;

////////////////////

// Affiche le contenu des informations de l'utilisateur slectionn dans ListBox1
procedure TForm1.AfficherInformationsPrivees;
begin
     if ListBox1.ItemIndex=-1 then exit;
     Label5.Caption:=Utilisateurs[ListBox1.ItemIndex].Nom;
     Label6.Caption:=Utilisateurs[ListBox1.ItemIndex].SID;
     if not FileExists(Utilisateurs[ListBox1.ItemIndex].Ruche) then Label7.Caption:='Introuvable'
        else Label7.Caption:=Utilisateurs[ListBox1.ItemIndex].Ruche;
     if (Utilisateurs[ListBox1.ItemIndex].Logged) then Label8.Caption:='OUI' else Label8.Caption:='NON';
     if (Utilisateurs[ListBox1.ItemIndex].SID<>'') and FileExists(Utilisateurs[ListBox1.ItemIndex].Ruche)
     then
     begin
          Edit1.Enabled:=true; Edit2.Enabled:=true; Edit3.Enabled:=true; Button1.Enabled:=true; Button2.Enabled:=true;
          if Visible and Edit1.Canfocus then Edit1.Setfocus;
     end
     else
     begin
          Edit1.Enabled:=false; Edit2.Enabled:=false; Edit3.Enabled:=false; Button1.Enabled:=false; Button2.Enabled:=false;
     end;
end;

// Lit les informations de utilisateurs
procedure TForm1.LireInformationsGenerales;
var i: integer;
begin
     ListBox1.Clear;
     Utilisateurs:=ListerUtilisateurs(checkBox1.checked);
     for i:=0 to length(Utilisateurs)-1 do
     ListBox1.Items.Add(Utilisateurs[i].Nom);
     if (ListBox1.ItemIndex=-1) and (ListBox1.Items.Count>0) then
     begin
          ListBox1.ItemIndex:=0;
          AfficherInformationsPrivees;
     end;
end;

// Assure l'accs au registre de l'utilisateur slectionn pour TypeAcces = lecture ou criture
procedure TForm1.AccesRegistre(TypeAcces: byte);
var ChargerRuche: TChargementRuche;
begin
     // Teste si le registre de l'utilisateur est dj charg
     if not Utilisateurs[ ListBox1.ItemIndex].Logged then
     begin
          // Chargement de la ruche
          ChargerRuche:=ChargerRucheUtilisateur(Utilisateurs, ListBox1.ItemIndex);
          if ChargerRuche.CodeErreur=ERROR_SUCCESS then
          begin
               ActionHKCU(TypeAcces, Utilisateurs, ListBox1.ItemIndex);
               // Dchargement de la ruche
               DechargerRucheUtilisateur(Utilisateurs, ListBox1.ItemIndex, ChargerRuche);
         end;
     end
     else ActionHKCU(TypeAcces, Utilisateurs, ListBox1.ItemIndex); // La ruche tait dj charge (utilisateur dj logu)
end;

// Lit ou Modifie les donnes de la ruche en mmoire
procedure TForm1.ActionHKCU(TypeAcces: byte; Utilisateurs: TUtilisateurs ; i: integer);
var Reg: TRegistry;
begin
     Reg:=TRegistry.Create;
     try
        Reg.RootKey:=HKEY_USERS;
        case TypeAcces of
        A_LIRE:
        begin
             if Reg.OpenKey(Utilisateurs[ i].SID+Edit1.Text, false) then
             begin
                  // Lire la valeur dans le registre de l'utilisateur
                  Edit3.Text:=Reg.ReadString(Edit2.Text);
             end;
        end;
        A_MODIFIER:
        begin
             if MessageDlg(#13+'Souhaitez-vous rellement modifier le registre de '+Utilisateurs[i].Nom+' ?', mtConfirmation,[mbYes,mbNo],0)=mrYes then
             begin
                  if Reg.OpenKey(Utilisateurs[ i].SID+Edit1.Text, false) then
                  begin
                       // Ecrit la valeur dans le registre de l'utilisateur
                       Reg.WriteString(Edit2.Text, Edit3.Text);
                  end;
             end;
        end;
        end;
        Reg.CloseKey;
     finally
        Reg.Free;
     end;
end;

end.
